<template>
    <div :id="idModal" class="uk-flex-top" uk-modal>
        <div class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical">
            <button
                class="uk-modal-close-default"
                type="button"
                uk-close
            ></button>

            <h2 class="uk-heading-bullet">Quels élèves :</h2>
            <AffichageClassesEleves
                v-if="classes.length > 0"
                :classes="classes"
                @action="enregistrerEleves"
            />
            <button
                class="action uk-button uk-button-default"
                v-on:click="affecter"
            >
                Envoyer
            </button>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import Axios from '@/auth/axiosAuth';
import UIkit from 'uikit';
// import UtilisateurSorter from '@/components/outils/UtilisateurSorter';
import AffichageClassesEleves from './AffichageClassesEleves.vue';
@Component({
    components: {
        AffichageClassesEleves
    }
})
export default class AffectationProbleme extends Vue {
    @Prop() problemes: any[];
    @Prop() idModal: string;

    private checked: any;
    private classes: any[] = [];

    beforeMount() {
        Axios.get('professeur/eleves/' + this.$auth.user.id, response => {
            this.classes = response.data;
        });
    }

    public affecter() {
        const data = new FormData();
        this.problemes.forEach(element => {
            data.append('problemes', element);
        });
        data.append('eleves', this.checked);
        data.append('professeur', this.$auth.user.id);
        Axios.post(
            'nouveauprobleme/',
            () => {
                UIkit.notification(
                    "<span uk-icon='icon: check'></span> Les problèmes ont été envoyés",
                    'success'
                );
                this.checked = [];
            },
            data
        );
    }

    private enregistrerEleves(elevesChecked: any[]) {
        this.checked = elevesChecked;
    }

    // private getElevesClasse(classe: Record<string, any>): any[] {
    //     const eleves = classe.eleves;
    //     UtilisateurSorter.comparerUtilisateurs(eleves);
    //     return eleves;
    // }
}
</script>

<style scoped>
.action {
    margin-top: 15px;
}
</style>
